DROP VIEW V_EMAIL;

CREATE OR REPLACE VIEW V_EMAIL
AS (
SELECT E.ID_EMAIL, E.DATUM_KREIRANJA, E.USER_KREIRANJA, E.ZADEVA, E.POSILJATELJ, E.STATUS, E.DATUM_POSILJANJA, E.AVTOMATSKO_KREIRANJE, E.PREJEMNIK_CC, 
E.PREJEMNIK_BCC, E.PREJEMNIK, E.TEKST, E.MESSAGE_ID, E.DATUM_PREJEMA, E.PREBRANO, E.STATUS_MESSAGE, E.CHECKED_ERROR, E.REFERENCE_ID, E.REFERENCE_TABLE, E.NNLOCATION_ID, E.CONFIDENTIAL,
K.ID AS KUPCI_ID, K.IME AS KUPCI_IME, K.PRIIMEK AS KUPCI_PRIIMEK, K.ID_MEMBER AS KUPCI_ID_MEMBER,
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
(CASE WHEN EXISTS (SELECT * FROM EMAILS_ATTACH EA WHERE EA.ID_EMAIL = E.ID_EMAIL) THEN 'Y' ELSE 'N' END) AS ATTACHMENT_PRESENT
FROM EMAILS E
LEFT OUTER JOIN (SELECT ID_KUPCA, ID_EMAIL, NPISMO, RANK() OVER (PARTITION BY ID_EMAIL ORDER BY ID_OPOMINI ASC) RNK FROM OPOMINI) O ON (O.ID_EMAIL = E.ID_EMAIL AND O.RNK = 1 AND O.NPISMO = 'E')
LEFT OUTER JOIN KUPCI K ON O.ID_KUPCA = K.ID
);

DROP VIEW V_KUPCI_EMAIL;

CREATE OR REPLACE VIEW V_KUPCI_EMAIL
AS (
SELECT O.ID_OPOMINI AS ID, O.LASTNIK_OBVESCEN, K.ID AS KUPCI_ID, K.PRIIMEK AS KUPCI_PRIIMEK, K.IME AS KUPCI_IME, K.ID_MEMBER AS KUPCI_ID_MEMBER, K.MANAGER AS KUPCI_MANAGER, K.VRSTA AS KUPCI_VRSTA, 
(CASE WHEN (SELECT VREDNOST FROM S_NASTAVITVE WHERE FILTER = 'MARINA' AND SEKCIJA = 'MARINA' AND NAZIV = 'ChangeFirstLastName') = '1' THEN (K.IME || ' ' || K.PRIIMEK) ELSE (K.PRIIMEK || ' ' || K.IME) END) AS OWNER,
E.ID_EMAIL AS EMAIL_ID_EMAIL, E.DATUM_KREIRANJA AS EMAIL_DATUM_KREIRANJA, E.USER_KREIRANJA AS EMAIL_USER_KREIRANJA,
E.TEKST AS EMAIL_TEKST, E.ZADEVA AS EMAIL_ZADEVA, E.POSILJATELJ AS EMAIL_POSILJATELJ, E.PREJEMNIK AS EMAIL_PREJEMNIK, E.STATUS AS EMAIL_STATUS, E.DATUM_POSILJANJA AS EMAIL_DATUM_POSILJANJA, E.AVTOMATSKO_KREIRANJE
AS EMAIL_AVTOMATSKO_KREIRANJE, E.PREJEMNIK_CC AS EMAIL_PREJEMNIK_CC, E.PREJEMNIK_BCC AS EMAIL_PREJEMNIK_BCC, E.PREBRANO AS EMAIL_PREBRANO, E.STATUS_MESSAGE AS EMAIL_STATUS_MESSAGE, E.NNLOCATION_ID AS EMAIL_NNLOCATION_ID,
E.CONFIDENTIAL AS EMAIL_CONFIDENTIAL,
(CASE WHEN EXISTS (SELECT * FROM EMAILS_ATTACH EA WHERE EA.ID_EMAIL = E.ID_EMAIL) THEN 'Y' ELSE 'N' END) AS ATTACHMENT_PRESENT
FROM OPOMINI O
LEFT OUTER JOIN KUPCI K ON K.ID = O.ID_KUPCA
LEFT OUTER JOIN EMAILS E ON E.ID_EMAIL = O.ID_EMAIL
WHERE O.NPISMO = (SELECT NPISMO FROM NPISMO N WHERE N.NPISMO_TYPE = 'EMAIL')
);

ALTER TABLE NNPRIVEZ
ADD WIND_DIRECTION VARCHAR2(3 CHAR);

DROP VIEW V_NNPRIVEZ;

CREATE OR REPLACE VIEW V_NNPRIVEZ AS (
SELECT N.ID_PRIVEZ, N.OBJEKT, N.N_PRIVEZA, N.KATEGORIJA, N.DOLZINA, N.GLOBINA, N.SIRINA, N.VISINA, N.LIMIT, N.ZASEDENO, N.SORT, N.SORT_PRIKAZ, N.DOCKWALK, N.SUBLEASE, 
N.RESERVATION_DEFAULT, N.DIRTY, N.ACTIVE, N.SURFACE, N.WIND_DIRECTION,
NPO.NAZIV AS NNPOMOL_NAZIV, NPO.INTERNI_OPIS AS NNPOMOL_INTERNI_OPIS, NPO.NNPOMOL_TYPE AS NNPOMOL_TYPE, NPO.NNLOCATION_ID, 
NOB.BERTH_NAME_BUILD_INSTRUCTION, NOB.STORAGE AS NNOBJEKT_STORAGE, NOB.OBJECT_TYPE AS NNOBJEKT_OBJECT_TYPE, NOB.OPIS AS NNOBJEKT_OPIS,
-- Last note
(SELECT PB.BELEZKA FROM PRIVEZIBELEZKE PB WHERE PB.ID_PRBELEZKE = (SELECT MAX(PB2.ID_PRBELEZKE) 
FROM PRIVEZIBELEZKE PB2 WHERE PB2.ID_PRIVEZ = N.ID_PRIVEZ AND PB.VELJAVNA = 'Y' AND COALESCE(PB.HIDDEN, 'N') <> 'Y')) AS LAST_NOTE,
-- Last 10 notes
(SELECT RTRIM(XMLAGG(XMLELEMENT(e, CASE WHEN SEQNUM <= 10 THEN BELEZKA END, ', ').EXTRACT('//text()') ORDER BY DATUMKREIRANJA DESC).getclobval(),', ') NOTES
FROM (SELECT PB.*, ROW_NUMBER() OVER (PARTITION BY ID_PRIVEZ ORDER BY DATUMKREIRANJA DESC) AS SEQNUM FROM PRIVEZIBELEZKE PB) PB
WHERE PB.ID_PRIVEZ = N.ID_PRIVEZ AND PB.VELJAVNA = 'Y' AND COALESCE(PB.HIDDEN, 'N') <> 'Y'
) AS NOTES
FROM NNPRIVEZ N
LEFT OUTER JOIN NNPOMOL NPO ON NPO.SIFRA = N.KATEGORIJA 
LEFT OUTER JOIN NNOBJEKT NOB ON NOB.SIFRA = N.OBJEKT
);

insert into verzije_baza
(id, dt_vpis, verzija, ver_nr, opis) values (2306, SYSDATE, '5.5', 2226, 'Email attachment')
;
